Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/IVReader/src/IVReader.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/IVReader/src/IVReader.vcproj	(revision 2183)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/IVReader/src/IVReader.vcproj	(revision 2228)
@@ -4,5 +4,5 @@
 	Version="7.10"
 	Name="IVReader"
-	ProjectGUID="{7319E499-473D-4CE5-9983-725D6E68A55D}"
+	ProjectGUID="{5776B40B-5FCE-46D5-8F7C-3912E24E0638}"
 	Keyword="Win32Proj">
 	<Platforms>
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2228)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2228)
@@ -0,0 +1,121 @@
+#!/bin/sh
+
+# add bin to path
+export PATH=../bin:$PATH
+
+#TARGET=debug
+TARGET=release
+
+PROGRAM=../bin/$TARGET/Preprocessor.exe
+
+SCENE=vienna_cropped.obj
+SCENE_PATH=../data/vienna
+
+#SCENE=arena-high-lods.obj
+#SCENE_PATH=../data/Arena
+
+ENVIRONMENT=gi_final.env
+
+LOG_PREFIX=../scripts/tests/gi/$SCENE
+#LOG_PREFIX=../scripts/tests/gi/vienna_cropped3
+
+echo "starting $TARGET mode for $SCENE scene ($PROGRAM)"
+
+
+##################################################################################
+
+USE_HEUR=true
+ METHOD=int-$USE_HEUR
+ echo "$SCENE $METHOD"
+
+
+#$PROGRAM $ENVIRONMENT \
+#-scene_filename=$SCENE_PATH/$SCENE \
+#  -view_cells_sampling_type=box \
+#  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+#  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+#  -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+#  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+#  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+#  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+ # -hierarchy_construction_type=2 \
+#  -hierarchy_construction_consider_memory=true \
+#  -bvh_use_sah=false \
+#  -vsp_use_cost_heuristics=$USE_HEUR
+
+#sh movefiles.sh $LOG_PREFIX-$METHOD
+
+#######################################################
+
+USE_HEUR=true
+ METHOD=int
+ echo "$SCENE $METHOD"
+
+
+$PROGRAM $ENVIRONMENT \
+  -scene_filename=$SCENE_PATH/$SCENE \
+  -view_cells_sampling_type=object_directional \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=2 \
+  -hierarchy_construction_min_avg_rays_per_object=1 \
+  -hierarchy_construction_max_avg_rays_per_object=20 \
+  -bvh_use_sah=false \
+  -vsp_use_cost_heuristics=$USE_HEUR
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
+
+#######################################################
+
+NODES=50000
+USE_HEUR=true
+#USE_HEUR=false
+  
+METHOD=seq-$NODES
+echo "$SCENE $METHOD"
+
+$PROGRAM $ENVIRONMENT \
+-scene_filename=$SCENE_PATH/$SCENE \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=0 \
+  -vsp_use_cost_heuristics=$USE_HEUR \
+  -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
+#######################################################
+
+NODES=10000
+USE_HEUR=true
+#USE_HEUR=false
+  
+METHOD=seq-$NODES
+echo "$SCENE $METHOD"
+
+$PROGRAM $ENVIRONMENT \
+-scene_filename=$SCENE_PATH/$SCENE \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=0 \
+  -vsp_use_cost_heuristics=$USE_HEUR \
+  -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env	(revision 2228)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env	(revision 2228)
@@ -0,0 +1,299 @@
+###############################################################################
+# ERS default configuration file
+# Jiri Bittner 2003
+#############################################################################
+
+Scene {
+
+	filename ../data/vienna/vienna_cropped.obj
+#	filename ../data/soda/soda.dat
+#	filename ../data/soda/soda5.dat
+#	filename ../data/artificial/cube_test.x3d
+#	filename ../data/CityModel.obj
+#	filename ../data/arena/arena-low-lods.obj
+}
+
+
+Preprocessor {
+	samplesPerPass 3000000
+	type vss
+	detectEmptyViewSpace true
+	loadMeshes false
+	# internal raycaster
+	#rayCastMethod 0  
+	# intel raycaster
+	rayCastMethod 1
+	exportVisibility false
+	applyVisibilityFilter false
+	applyVisibilitySpatialFilter false
+}
+
+
+RssPreprocessor {
+	distributions mutation+spatial+object_direction
+	#distributions spatial
+
+
+	useImportanceSampling true
+
+	Export {
+		pvs false
+		rssTree false
+	}
+
+	useViewcells true
+	updateSubdivision true
+	loadInitialSamples false
+	storeInitialSamples false
+
+	useRssTree true
+}
+
+
+
+VssTree {
+	useRss    	false
+	epsilon		1e-6
+	
+	maxDepth 	2
+	minPvs		30
+	minRays		800
+	minSize		0.001
+ 	maxCostRatio	1.5
+	maxRayContribution 0.5
+		
+	maxTotalMemory	50
+	maxStaticMemory	20
+	
+	splitType regular
+	#	splitType heuristic
+	#	splitType hybrid
+	splitUseOnlyDrivingAxis true
+	
+	interleaveDirSplits	true
+    	dirSplitDepth 0
+	
+	numberOfEndPointDomains	10000
+	ct_div_ci	0.0
+	randomize	false
+	
+	refDirBoxMaxSize	0.1
+}
+
+
+Limits {
+       threshold	1e-6
+       small		1e-6
+       infinity		1e9
+}
+
+
+Unigraphics {
+	meshGrouping 1
+}
+
+
+KdTree {
+	sahUseFaces true
+
+	Termination {
+		minCost 0
+		maxDepth 20
+		
+		maxCostRatio 1.5
+		ct_div_ci 0.5
+	}
+
+#	splitMethod spatialMedian
+	splitMethod SAH
+	splitBorder 0.01
+}
+
+MeshKdTree {
+	Termination {
+		minCost 1
+		maxDepth 18
+		maxCostRatio 0.9
+		ct_div_ci 0.5
+	}
+
+#	splitMethod spatialMedian
+	splitMethod SAH
+	splitBorder 0.01
+}
+
+
+ViewCells {
+	
+	# samples used for view cell construction in the merge step
+	Construction {
+		samples 0
+		samplesPerPass 1000000
+	}
+
+	# number of active view cells
+	active 25000
+	maxStaticMemory	40
+
+	exportToFile true
+	loadFromFile false
+
+	#exportPvs true
+
+	# type of view cells
+	type vspOspTree
+	
+	#percentage of total visible objects where pvs is considered invalid
+	maxPvsRatio 1.0
+		
+	processOnlyValidViewCells false
+
+	samplingType box
+
+	PostProcess {
+		# how much samples are used for post processing
+		samples 0
+		maxMergesPerPass 5000
+		useRaysForMerge false
+		refine false
+		compress true
+		merge false
+	}
+
+	Visualization {
+		# how much samples we use for visualization
+		samples 200
+		exportRays true
+		exportGeometry true
+		exportMergedViewCells false
+		useClipPlane true
+		clipPlaneAxis 1
+		clipPlanePos 0.3
+		maxOutput 0
+	}
+
+	showVisualization true
+	#showVisualization false
+	evaluateViewCells true
+	
+	Evaluation {
+		#samples         200000000
+		#samplesForStats 100000000
+		samples          60000000
+		samplesForStats  30000000
+
+		samplesPerPass  1000000
+
+#		#stepSize	500
+		stepSize	100
+
+		samplingType box
+
+		histogram true
+		histoStepSize 200
+		histoMem 60
+
+		statsPrefix ../scripts/viewCells
+	}
+}
+
+
+################################
+#
+# View space partitioning kd tree
+#
+
+VspTree {
+	Construction {
+		renderCostDecreaseWeight 0.999
+	}
+
+	Termination {
+		minPvs 0
+		maxViewCells 500000
+	}
+
+	useCostHeuristics true
+	#splitUseOnlyDrivingAxis true
+
+	#useCostHeuristics false
+	splitUseOnlyDrivingAxis false
+
+	# maximum number of tests per node
+	maxTests 1000000
+}
+
+
+
+#
+# The bounding volume hierarchy
+#
+
+BvHierarchy {
+
+	Construction {		
+		renderCostDecreaseWeight 0.999
+	}
+
+	Termination {
+		maxLeaves 50000000
+	}
+
+	minRaysForVisibility 3
+	#minRaysForVisibility 15
+
+	# use only surface area heuristic
+	useCostHeuristics true
+	#useCostHeuristics false
+	useSah false
+
+	#splitUseOnlyDrivingAxis true
+	splitUseOnlyDrivingAxis false
+
+	maxTests 50000000
+}
+
+
+###############################################################
+#
+# Manages the construction of view space and object space partition
+#
+
+Hierarchy {
+	# the type of object space partition: view space is always vsp (=kd) partition
+	type bvh
+	
+	Construction {
+
+		samples 5000000
+
+		# type 0 = sequential computation, 1 = interleaved, 2 = gradient
+		type 2
+
+		###############################
+		# only for interleaved method
+
+		# if dirty split candidates are reevaluated 
+		repairQueue true
+
+		###################################################
+
+		# minimal steps of same type: for interleaved, this is only valid for the first few splits
+		minStepsOfSameType 100
+		#maxStepsOfSameType 3000
+		maxStepsOfSameType 1000
+
+		maxRepairs 1000
+	}
+
+	Termination {
+		# maximal number of leaves
+		maxLeaves 300000
+#		maxLeaves 6000
+		# maximal memory in MB
+#		maxMemory 4
+		maxMemory 30
+		# minimum ratio of global cost decrease
+		minGlobalCostRatio -1
+	}
+}
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility_internal.sh
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility_internal.sh	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/preprocess_visibility_internal.sh	(revision 2228)
@@ -14,5 +14,5 @@
 
 NUM_SAMPLE_RAYS=200000000
-NUM_SAMPLE_RAYS=50000000
+#NUM_SAMPLE_RAYS=50000000
 
 $PREPROCESSOR -total_samples=$NUM_SAMPLE_RAYS \
Index: GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 2206)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 2228)
@@ -257,12 +257,15 @@
 				GlobalOptimizations="TRUE"
 				InlineFunctionExpansion="2"
-				FavorSizeOrSpeed="1"
+				EnableIntrinsicFunctions="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
 				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="3"
+				OptimizeForProcessor="1"
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;NO_QT"
 				RuntimeLibrary="2"
-				RuntimeTypeInfo="TRUE"
+				EnableEnhancedInstructionSet="2"
+				RuntimeTypeInfo="FALSE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
@@ -281,4 +284,5 @@
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
+				OptimizeForWindows98="1"
 				TargetMachine="1"
 				FixedBaseAddress="1"/>
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj	(revision 2199)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj	(revision 2228)
@@ -236,5 +236,5 @@
 				OptimizeForWindowsApplication="1"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(CG_INC_PATH)&quot;;Timer;..\src\sparsehash\src\google\sparsehash;..\src\sparsehash\src\windows;..\src\sparsehash\src\google;..\src\sparsehash\src;..\src\ootl\;..\src\ootl\src\;..\src\ootl\src\cpp;..\src\ootl\src\cpp\include\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;..\src\ootl\src\cpp\include\ootl\mswin"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_HASH_PVS"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_HASH_PV"
 				ExceptionHandling="1"
 				RuntimeLibrary="2"
@@ -275,6 +275,6 @@
 			<Tool 
 				Name="GeneralTool"
-				OutputDirectory="$(ConfigurationName)"
-				IntermediateDirectory="$(ConfigurationName)"
+				OutputDirectory="Release"
+				IntermediateDirectory="Release"
 				ConfigurationType="4"
 				CharacterSet="2"/>
@@ -290,7 +290,7 @@
 				OmitFramePointers="1"
 				EnableFiberSafeOptimizations="1"
-				OptimizeForProcessor="0"
+				OptimizeForProcessor="1"
 				OptimizeForWindowsApplication="1"
-				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;Timer"
+				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;NO_QT"
 				StringPooling="1"
@@ -305,5 +305,7 @@
 				WarningLevel="2"
 				Detect64BitPortabilityProblems="1"
-				DebugInformationFormat="3"/>
+				DebugInformationFormat="3"
+				UseProcExt="3"
+				RequireProcExt="3"/>
 			<Tool 
 				Name="LinkerTool"
@@ -468,4 +470,6 @@
 			RelativePath=".\HashPvs.h"/>
 		<File 
+			RelativePath=".\HashPvs2.h"/>
+		<File 
 			RelativePath=".\HierarchyManager.cpp"/>
 		<File 
@@ -932,7 +936,7 @@
 			RelativePath=".\sparsehash\src\google\sparsehash\densehashtable.h"/>
 		<File 
+			RelativePath=".\sparsehash\src\google\sparsehash\hash_fun.h"/>
+		<File 
 			RelativePath=".\sparsehash\src\windows\hash_fun.h"/>
-		<File 
-			RelativePath=".\sparsehash\src\google\sparsehash\hash_fun.h"/>
 		<File 
 			RelativePath=".\sparsehash\src\windows\hash_map.h"/>
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2228)
@@ -2680,4 +2680,9 @@
 					"100000");
 
+	RegisterOption("Hierarchy.minRenderCost",
+					optFloat,
+					"hierarchy_minRenderCost=",
+					"0");
+
 	RegisterOption("Hierarchy.subdivisionStats",
         		   optString,
@@ -2778,10 +2783,10 @@
 					optFloat,
 					"hierarchy_construction_max_avg_rays_per_object=",
-					"2");
+					"0");
 	
 	RegisterOption("Hierarchy.Construction.minAvgRaysPerObject",
 					optFloat,
 					"hierarchy_construction_min_avg_rays_per_object=",
-					"1");
+					"0");
 	
 	RegisterOption("Hierarchy.useTraversalTree",
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2206)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2228)
@@ -260,6 +260,6 @@
 		<Configuration
 			Name="release_noqt|Win32"
-			OutputDirectory="$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="Release"
+			IntermediateDirectory="Release"
 			ConfigurationType="4"
 			CharacterSet="2">
@@ -267,15 +267,21 @@
 				Name="VCCLCompilerTool"
 				Optimization="3"
-				InlineFunctionExpansion="0"
-				FavorSizeOrSpeed="0"
-				OptimizeForProcessor="3"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="2"
+				EnableIntrinsicFunctions="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
+				EnableFiberSafeOptimizations="TRUE"
+				OptimizeForProcessor="1"
 				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;NO_QT"
+				StringPooling="TRUE"
 				ExceptionHandling="TRUE"
 				RuntimeLibrary="2"
+				EnableEnhancedInstructionSet="2"
 				DisableLanguageExtensions="FALSE"
 				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
+				RuntimeTypeInfo="FALSE"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
@@ -1160,8 +1166,8 @@
 			</File>
 			<File
+				RelativePath=".\sparsehash\src\windows\hash_fun.h">
+			</File>
+			<File
 				RelativePath=".\sparsehash\src\google\sparsehash\hash_fun.h">
-			</File>
-			<File
-				RelativePath=".\sparsehash\src\windows\hash_fun.h">
 			</File>
 			<File
Index: GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2228)
@@ -625,4 +625,6 @@
 	bool mUseTraversalTree;
 
+	float mMinRenderCost;
+
 protected:
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2228)
@@ -1024,5 +1024,5 @@
 	/** Returns true if global tree can be terminated.
 	*/
-	inline bool GlobalTerminationCriteriaMet(const VspTraversalData &data) const;
+	bool GlobalTerminationCriteriaMet(const VspTraversalData &data) const;
 
 	/** Adds ray sample contributions to the PVS.
Index: GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2228)
@@ -1118,4 +1118,5 @@
 		ar = rbox.SurfaceArea();
 
+		// should use classical approach here ...
 #if BOUND_RENDERCOST
 		const float sum = noValidSplit ? 1e25f : objectsLeft * al + objectsRight * ar;
@@ -1890,6 +1891,6 @@
 	//-- surface area heuristics
 
-	if (leaf->mObjects.empty())
-		return 0.0f;
+	// eraly exit
+	//if (leaf->mObjects.empty())	return 0.0f;
 
 	const AxisAlignedBox3 box = GetBoundingBox(leaf);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2228)
@@ -2488,5 +2488,6 @@
 	  stat.avgFilterRatio/=stat.viewcells; 
 	  stat.avgRelPvsIncrease/=stat.viewcells;
-	  
+	  stat.renderCostRatio=stat.renderCost / stat.mem;
+
 	  // evaluate std deviation of relPvsIncrease
 	  float sum=0.0f;
@@ -2518,5 +2519,5 @@
   s<<"#DEV_REL_PVS_INCREASE\n"<<pvsStat.devRelPvsIncrease<<endl;
   s<<"#MEMORY\n"<<pvsStat.mem<<endl;
-
+  s<<"#RATIO\n"<<pvsStat.renderCost / (pvsStat.mem + Limits::Small)<<endl;
   s<<"#CONTRIBUTING_RAYS\n"<<mSamplesStat.mContributingRays<<endl;
 
@@ -6875,5 +6876,6 @@
 		Debug << "finished in " << timeDiff * 1e-3f << " secs" << endl;
 		
-		// don't use sample contributions because already accounted for inside the mixture distribution!
+		// don't computed sample contributions 
+		// because already accounted for inside the mixture distribution!
 		
 		castSamples += samplesPerPass;
@@ -6948,5 +6950,5 @@
 	////////////
 	//-- histogram
-#if 1
+
 	const int numLeaves = mViewCellsTree->GetNumInitialViewCells(mViewCellsTree->GetRoot());
 	int histoStepSize;
@@ -6981,5 +6983,4 @@
 		}
 	}
-#endif
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2228)
@@ -1343,4 +1343,23 @@
 
 #endif
+#if VISUALIZE_SPLIT
+	Exporter *exporter = Exporter::GetExporter("split.wrl");
+	exporter->ExportBox(box);
+
+		RayInfoContainer::const_iterator rit, rit_end = tData.mRays->end();
+
+	for (rit = tData.mRays->begin(); rit != rit_end; ++ rit)
+	{
+		RayInfo rayInf = *rit;
+
+		VssRay *ray = rayInf.mRay;
+		
+		exporter->ExportIntersectable(GetParentObject(ray->mTerminationObject));
+
+		AxisAlignedBox3 candidatePlane;
+		exporter->ExportBox(candidatePlane);
+	}
+    delete exporter;
+#endif
 	for (ci = mLocalSubdivisionCandidates->begin(); ci != ci_end; ++ ci)
 	{
Index: GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj	(revision 2199)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj	(revision 2228)
@@ -204,5 +204,6 @@
 				OptimizeForWindowsApplication="1"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;$(NOINHERIT)"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_HASH_PVS"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_HASH_PV"
+				StringPooling="1"
 				ExceptionHandling="1"
 				RuntimeLibrary="2"
@@ -266,10 +267,8 @@
 				OmitFramePointers="1"
 				EnableFiberSafeOptimizations="1"
-				OptimizeForProcessor="0"
+				OptimizeForProcessor="1"
 				OptimizeForWindowsApplication="1"
 				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL;NO_QT"
-				StringPooling="1"
-				MinimalRebuild="0"
 				RuntimeLibrary="2"
 				EnableEnhancedInstructionSet="2"
@@ -278,5 +277,7 @@
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="1"
-				DebugInformationFormat="3"/>
+				DebugInformationFormat="3"
+				UseProcExt="3"
+				RequireProcExt="3"/>
 			<Tool 
 				Name="LinkerTool"
@@ -285,8 +286,7 @@
 				OutputFile="../bin/release/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release"
-				GenerateDebugInformation="0"
-				SubSystem="1"
-				LargeAddressAware="0"
+				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release;&quot;$(QTDIR)\lib&quot;;.\QtGlRenderer\Release"
+				GenerateDebugInformation="0"
+				SubSystem="1"
 				OptimizeReferences="2"
 				EnableCOMDATFolding="2"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2227)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2228)
@@ -105,4 +105,7 @@
 	Environment::GetSingleton()->GetFloatValue(
 		"Hierarchy.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
+
+	Environment::GetSingleton()->GetFloatValue("Hierarchy.minRenderCost", mMinRenderCost);
+
 	Environment::GetSingleton()->GetIntValue(
 		"Hierarchy.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
@@ -179,4 +182,5 @@
 	Debug << "max avg rays per object: " << mMaxAvgRaysPerObject << endl;
 	Debug << "mín avg rays per object: " << mMinAvgRaysPerObject << endl;
+	Debug << "mín render cost: " << mMinRenderCost << endl;
 
 	// for comparing it with byte - value
@@ -833,4 +837,10 @@
 										 const float avgRaysPerObjects) const
 {
+	// don't correct pvss
+	if (mMaxAvgRaysPerObject <= mMinAvgRaysPerObject)
+	{
+		return childPvs;
+	}
+	
 	// assume pvs sampled sufficiently => take child pvs
 	if (avgRaysPerObjects > mMaxAvgRaysPerObject)
@@ -838,10 +848,15 @@
 		return childPvs;
 	}
-	// assume pvs not sampled sufficiently => take total pvs
-	else if (avgRaysPerObjects <= mMinAvgRaysPerObject)
-	{
-		cout << "b ";// << avgRaysPerObjects << " ";
+
+	// assume pvs not sampled sufficiently => pvs equal to parent pvs
+	// we should not subdivide further from this point
+	if (avgRaysPerObjects <= mMinAvgRaysPerObject)
+	{
+		cout << "t ";// << avgRaysPerObjects << " ";
 		return totalPvs;
 	}
+
+	///////////
+	//-- blend pvss
 
 	const float alpha = (mMaxAvgRaysPerObject - avgRaysPerObjects) / 
@@ -857,5 +872,5 @@
 	const float newPvs = alpha * childPvs + (1.0f - alpha) * totalPvs;
 #endif
-cout << "c ";// << avgRaysPerObjects << " ";
+cout << "b ";// << avgRaysPerObjects << " ";
 	//cout << "alpha " << alpha << " beta: " << beta << " child: " << childPvs << " parent: " << totalPvs << endl;
 	
@@ -927,4 +942,6 @@
 	
 	mPriority = sc->GetPriority();
+
+	cout << sc->Type() << " ";
 
 	//////////
@@ -1160,6 +1177,5 @@
 		{
 			//sc->CollectDirtyCandidates(dirtyCandidates, true);
-			//if (steps % 10 == 0)
-				cout << sc->Type() << " ";
+			//if (steps % 10 == 0) cout << sc->Type() << " ";
 			
 			++ steps;
